Share of Total in JavaScript

Using ApexCharts with JavaScript

This Share of Total example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [
    {
      name: 'Chrome',
      data: [64, 65, 63, 62, 60, 58, 56],
    },
    {
      name: 'Safari',
      data: [16, 17, 19, 20, 22, 24, 25],
    },
    {
      name: 'Edge',
      data: [3, 5, 7, 9, 11, 12, 14],
    },
    {
      name: 'Firefox',
      data: [10, 9, 8, 6, 5, 4, 3],
    },
    {
      name: 'Other',
      data: [7, 4, 3, 3, 2, 2, 2],
    },
  ],
  chart: {
    type: 'streamgraph',
    height: 380,
  },
  colors: ['#0EA5E9', '#22C55E', '#F97316', '#EF4444', '#14B8A6'],
  plotOptions: {
    streamgraph: {
      // Each column normalized to its own total, so the chart reads as
      // composition over time rather than volume.
      offset: 'expand',
      order: 'inverse',
    },
  },
  title: {
    text: 'Share of page views by browser',
    align: 'left',
  },
  subtitle: {
    text: 'Illustrative data. Every column is 100% tall, so only the mix moves.',
    align: 'left',
  },
  xaxis: {
    categories: ['2019', '2020', '2021', '2022', '2023', '2024', '2025'],
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Share of Total in Vue

Using ApexCharts with Vue

This Share of Total example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="streamgraph"
        height="380"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Chrome',
          data: [64, 65, 63, 62, 60, 58, 56],
        },
        {
          name: 'Safari',
          data: [16, 17, 19, 20, 22, 24, 25],
        },
        {
          name: 'Edge',
          data: [3, 5, 7, 9, 11, 12, 14],
        },
        {
          name: 'Firefox',
          data: [10, 9, 8, 6, 5, 4, 3],
        },
        {
          name: 'Other',
          data: [7, 4, 3, 3, 2, 2, 2],
        },
      ],
      chartOptions: {
        chart: {
          type: 'streamgraph',
          height: 380,
        },
        colors: ['#0EA5E9', '#22C55E', '#F97316', '#EF4444', '#14B8A6'],
        plotOptions: {
          streamgraph: {
            // Each column normalized to its own total, so the chart reads as
            // composition over time rather than volume.
            offset: 'expand',
            order: 'inverse',
          },
        },
        title: {
          text: 'Share of page views by browser',
          align: 'left',
        },
        subtitle: {
          text: 'Illustrative data. Every column is 100% tall, so only the mix moves.',
          align: 'left',
        },
        xaxis: {
          categories: ['2019', '2020', '2021', '2022', '2023', '2024', '2025'],
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>

Share of Total in React

Using ApexCharts with React

This Share of Total example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Chrome',
        data: [64, 65, 63, 62, 60, 58, 56],
      },
      {
        name: 'Safari',
        data: [16, 17, 19, 20, 22, 24, 25],
      },
      {
        name: 'Edge',
        data: [3, 5, 7, 9, 11, 12, 14],
      },
      {
        name: 'Firefox',
        data: [10, 9, 8, 6, 5, 4, 3],
      },
      {
        name: 'Other',
        data: [7, 4, 3, 3, 2, 2, 2],
      },
    ],
    options: {
      chart: {
        type: 'streamgraph',
        height: 380,
      },
      colors: ['#0EA5E9', '#22C55E', '#F97316', '#EF4444', '#14B8A6'],
      plotOptions: {
        streamgraph: {
          // Each column normalized to its own total, so the chart reads as
          // composition over time rather than volume.
          offset: 'expand',
          order: 'inverse',
        },
      },
      title: {
        text: 'Share of page views by browser',
        align: 'left',
      },
      subtitle: {
        text: 'Illustrative data. Every column is 100% tall, so only the mix moves.',
        align: 'left',
      },
      xaxis: {
        categories: ['2019', '2020', '2021', '2022', '2023', '2024', '2025'],
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="streamgraph"
          height={380}
        />
      </div>
    </div>
  )
}

export default ApexChart

Share of Total in Angular

Using ApexCharts with Angular

This Share of Total example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Chrome',
              data: [64, 65, 63, 62, 60, 58, 56],
            },
            {
              name: 'Safari',
              data: [16, 17, 19, 20, 22, 24, 25],
            },
            {
              name: 'Edge',
              data: [3, 5, 7, 9, 11, 12, 14],
            },
            {
              name: 'Firefox',
              data: [10, 9, 8, 6, 5, 4, 3],
            },
            {
              name: 'Other',
              data: [7, 4, 3, 3, 2, 2, 2],
            },
          ],
          chart: {
            type: 'streamgraph',
            height: 380,
          },
          colors: ['#0EA5E9', '#22C55E', '#F97316', '#EF4444', '#14B8A6'],
          plotOptions: {
            streamgraph: {
              // Each column normalized to its own total, so the chart reads as
              // composition over time rather than volume.
              offset: 'expand',
              order: 'inverse',
            },
          },
          title: {
            text: 'Share of page views by browser',
            align: 'left',
          },
          subtitle: {
            text: 'Illustrative data. Every column is 100% tall, so only the mix moves.',
            align: 'left',
          },
          xaxis: {
            categories: ['2019', '2020', '2021', '2022', '2023', '2024', '2025'],
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}